/*
*
* Copyright (c) 2004 Sun Microsystems, Inc.
* All rights reserved.
* You may not modify, use, reproduce, or distribute this software except in compliance with the terms
* of the License at: http://developer.sun.com/berkeley_license.html
* Author : Sameer Tyagi, Sun Microsystems s.t@sun.com
* "Patterns and Strategies for Building Document-Based Web Services"
*  http://java.sun.com/developer/technicalArticles/xml/jaxrpcpatterns
*/

import com.examples.attachmentservice.clientbindings.*;

import javax.activation.*;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import java.io.File;

public class WSDLClient {
    public static void main(String[] args) {
        try {
            String url = "http://127.0.0.1:9090/attachments-java/jaxrpc";
            String filename = "Uploadme.doc";
            String xmlfilename = "purchaseorder.xml";
            if (args.length == 3) {
                url = args[0];
                filename = args[1];
                xmlfilename = args[2];
            }
            AttachmentService_PortType_Stub stub = (AttachmentService_PortType_Stub) (new AttachmentService_Service_Impl().getAttachmentServicePort());
            stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, url);

            sentAttachmentWithSource(xmlfilename, stub);
            sendAttachmentWithDataHandler(filename, stub);


        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void sendAttachmentWithDataHandler(String filename, AttachmentService_PortType_Stub stub) throws Exception {
        DataHandler dh = new DataHandler(new FileDataSource(filename));
        String response = stub.storeDocumentService(dh, filename);
        System.out.println("Response from server " + response);
    }

    private static void sentAttachmentWithSource(String filename, AttachmentService_PortType_Stub stub) throws Exception {
        Source src = new StreamSource(new File(filename));
        String response = stub.storeDocumentXML(src, filename);
        System.out.println("Response from server " + response);
    }

}
