/*
*
* Copyright (c) 2004 Sun Microsystems, Inc.
* All rights reserved.
* You may not modify, use, reproduce, or distribute this software except in compliance with the terms
* of the License at: http://developer.sun.com/berkeley_license.html
* Author : Sameer Tyagi, Sun Microsystems s.t@sun.com
* "Patterns and Strategies for Building Document-Based Web Services"
*  http://java.sun.com/developer/technicalArticles/xml/jaxrpcpatterns
*/
package com.examples.attachmentservice;

import javax.activation.DataHandler;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Date;

public class AttachmentServiceImpl implements AttachmentService {

    /**
     * This method implements a web service that stores any attachment it receives.
     */
    public String storeDocumentService(DataHandler dh, String filename) {
        try {
            System.out.println(" >>>> storeDocumentService storing file to  " + "/" + filename);
            BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream("/" + filename));
            BufferedInputStream in = new BufferedInputStream(dh.getInputStream());

            byte[] buffer = new byte[256];
            while (true) {
                int bytesRead = in.read(buffer);
                if (bytesRead == -1)
                    break;
                out.write(buffer, 0, bytesRead);
            }
            in.close();
            out.close();
        } catch (Exception e) {
            System.out.println(e);
            return e.toString();
        }
        return ("File processes succesfully " + filename + "  " + new Date());
    }


    public String storeDocumentXML(Source dh, String filename) {

        try {
            System.out.println(" >>>> storeDocumentService storing file to  " + "/" + filename);
            TransformerFactory factory = TransformerFactory.newInstance();
            Transformer transformer = factory.newTransformer();
            // also print to console
            File f = new File("/" + filename);
            transformer.transform(dh, new StreamResult(f));

        } catch (Exception e) {
            System.out.println(e);
        }
        return ("File processes succesfully " + filename + "  " + new Date());
    }


}